Index: branches/HTM-9.0-dev0/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibCommon/CommonDef.h	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibCommon/CommonDef.h	(revision 730)
@@ -121,7 +121,6 @@
 #define MAX_UINT                    0xFFFFFFFFU ///< max. value of unsigned 32-bit integer
 #define MAX_INT                     2147483647  ///< max. value of signed 32-bit integer
-#if H_3D
 #define MIN_INT                     (-2147483647-1) // < min. value of signed 32-bit integer
-#endif
+
 #define MAX_INT64                   0x7FFFFFFFFFFFFFFFLL  ///< max. value of signed 64-bit integer
 #define MAX_DOUBLE                  1.7e+308    ///< max. value of double-type value
Index: branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 730)
@@ -503,7 +503,7 @@
 {
   if ( legend )
-    std::cout  << "LId"        << "\t" << "POC"   << "\t" << "Rec"          << "\t" << "Ref"                       << "\t" << "LT"            << std::endl;
+    std::cout  << std::endl << "LId"        << "\t" << "POC"   << "\t" << "Rec"          << "\t" << "Ref"                       << "\t" << "LT"            <<  "\t" << "OutMark" <<  "\t" << "OutFlag" << std::endl;
   else
-    std::cout  << getLayerId() << "\t" << getPOC()<< "\t" << getReconMark() << "\t" << getSlice(0)->isReferenced() << "\t" << getIsLongTerm() << std::endl;
+    std::cout  << getLayerId() << "\t" << getPOC()<< "\t" << getReconMark() << "\t" << getSlice(0)->isReferenced() << "\t" << getIsLongTerm() << "\t" << getOutputMark() << "\t" << getSlice(0)->getPicOutputFlag() <<std::endl;
 }
 
@@ -524,5 +524,4 @@
   return pcPic;
 }
-
 #if H_3D
 TComPic* TComPicLists::getPic( Int viewIndex, Bool depthFlag, Int poc )
@@ -530,5 +529,5 @@
   return getPic   ( m_vps->getLayerIdInNuh( viewIndex, depthFlag ), poc );
 }
-
+#endif
 Void TComPicLists::print()
 {
@@ -571,4 +570,5 @@
 }
 
+#if H_3D
 TComPicYuv* TComPicLists::getPicYuv( Int viewIndex, Bool depthFlag, Int poc, Bool recon )
 {  
@@ -576,4 +576,5 @@
   return getPicYuv( layerIdInNuh, poc, recon );
 }
+
 #if H_3D_ARP
 TComList<TComPic*>* TComPicLists::getPicList( Int layerIdInNuh )
@@ -593,5 +594,5 @@
 }
 #endif
-#endif // H_3D
+#endif
 #endif // H_MV
 
Index: branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 730)
@@ -573,5 +573,9 @@
 #if H_MV_ENC_DEC_TRAC
 #if ENC_DEC_TRACE
+#if H_MV_FIX_TRACE_FILE
+Void writeToTraceFile( const Char* symbolName, Int val, Bool doIt )
+#else
 Void writeToTraceFile( Char* symbolName, Int val, Bool doIt )
+#endif
 {
   if ( ( ( g_nSymbolCounter >= COUNTER_START && g_nSymbolCounter <= COUNTER_END )|| g_bJustDoIt ) && doIt  ) 
@@ -588,5 +592,9 @@
 }
 
+#if H_MV_FIX_TRACE_FILE
+Void writeToTraceFile( const Char* symbolName, Bool doIt )
+#else
 Void writeToTraceFile( Char* symbolName, Bool doIt )
+#endif
 {
   if ( ( ( g_nSymbolCounter >= COUNTER_START && g_nSymbolCounter <= COUNTER_END )|| g_bJustDoIt ) && doIt  ) 
Index: branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComRom.h
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComRom.h	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComRom.h	(revision 730)
@@ -236,6 +236,11 @@
 
 
+#if H_MV_FIX_TRACE_FILE
+ Void           writeToTraceFile( const Char* symbolName, Int val, Bool doIt );
+ Void           writeToTraceFile( const Char* symbolName, Bool doIt );
+#else
  Void           writeToTraceFile( Char* symbolName, Int val, Bool doIt );
  Void           writeToTraceFile( Char* symbolName, Bool doIt );
+#endif
 #endif
 #else
Index: branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 729)
+++ branches/HTM-9.0-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 730)
@@ -110,4 +110,7 @@
 #endif
 , m_pocResetFlag                  (false)
+#if H_MV_6_RALS_O0149_11
+, m_crossLayerBlaFlag             (false)
+#endif
 , m_discardableFlag               (false)
 , m_interLayerPredEnabledFlag     (false)
@@ -148,5 +151,5 @@
   for (Int i = 0; i < MAX_NUM_LAYERS; i++ )
   {
-   m_interLayerPredLayerIdc[ i ] = i;
+    m_interLayerPredLayerIdc[ i ] = -1;
   }
 #endif
@@ -1709,6 +1712,9 @@
 , m_hrdOpSetIdx               (NULL)
 , m_cprmsPresentFlag          (NULL)
+#if H_MV_6_HRD_O0217_13
+, m_dpbSize                   (NULL)
+#endif
 #if H_MV
-, m_vpsVUI                 (  NULL )
+, m_vpsVUI                    (NULL)
 #endif
 {
@@ -1724,5 +1730,9 @@
     for( Int layerId = 0; layerId < MAX_VPS_NUH_LAYER_ID_PLUS1; layerId++ )
     {
+#if H_MV_6_HRD_O0217_13
+      m_layerIdIncludedFlag[lsIdx][layerId] = (( lsIdx == 0 ) && ( layerId == 0 )) ; 
+#else
       m_layerIdIncludedFlag[lsIdx][layerId] = false; 
+#endif
     }
   } 
@@ -1738,5 +1748,9 @@
   m_moreOutputLayerSetsThanDefaultFlag = false;   
   m_numAddOutputLayerSetsMinus1        = -1;   
+#if H_MV_6_PS_0109_25
+  m_defaultOneTargetOutputLayerIdc     = 0; 
+#else
   m_defaultOneTargetOutputLayerFlag    = false; 
+#endif
   
   for ( Int i = 0; i < MAX_VPS_OUTPUTLAYER_SETS; i++)
@@ -1748,6 +1762,8 @@
       m_outputLayerFlag[i][j] = false; 
     }
-  }
-  
+  }  
+#if H_MV_6_GEN_0153_28
+  m_altOutputLayerFlag       = false; 
+#endif
   m_maxOneActiveRefLayerFlag = false; 
   m_directDepTypeLenMinus2   = 0;         
@@ -1786,6 +1802,11 @@
     m_layerIdInNuh      [i] = ( i == 0 ) ? 0 : -1; 
     m_numDirectRefLayers[i] = 0; 
+#if !H_MV_6_ILDDS_O0225_30
     m_maxTidIlRefPicPlus1[i] = 7;
+#endif
     m_vpsRepFormatIdx    [i] = 0; 
+#if H_MV_6_MISC_O0062_31
+    m_pocLsbNotPresentFlag[i] = 0;
+#endif
     m_repFormat          [i] = NULL; 
     m_viewIdVal          [i] = 0; 
@@ -1821,4 +1842,7 @@
       m_directDependencyType[i][j] = -1; 
       m_refLayerId[i][j]           = -1; 
+#if H_MV_6_ILDDS_O0225_30      
+      m_maxTidIlRefPicsPlus1[i][j]  = 7;
+#endif
     }
 
@@ -1833,4 +1857,8 @@
   }
   m_vpsVUI = new TComVPSVUI; 
+#if H_MV_6_HRD_O0217_13
+  m_dpbSize = new TComDpbSize; 
+#endif
+#
 #if H_3D
   for( Int i = 0; i < MAX_NUM_LAYERS; i++ )
@@ -1866,4 +1894,8 @@
 #if H_MV
   if ( m_vpsVUI          != NULL )     delete m_vpsVUI; 
+#if H_MV_6_HRD_O0217_13
+  if ( m_dpbSize         != NULL )     delete m_dpbSize; 
+#endif
+
   for( Int i = 0; i < MAX_NUM_LAYERS; i++ )
   {
@@ -2068,4 +2100,7 @@
   assert( lsIdx >= 0 ); 
   assert( lsIdx <= getVpsNumLayerSetsMinus1() ); 
+#if H_MV_6_HRD_O0217_13
+  return (Int) m_layerSetLayerIdList[ lsIdx ].size(); 
+#else
   Int numLayersInIdList = 0; 
   for (Int layerId = 0; layerId < getVpsMaxLayerId(); layerId++ )
@@ -2073,6 +2108,21 @@
     numLayersInIdList += ( getLayerIdIncludedFlag( lsIdx, layerId ) ); 
   }
+
   return numLayersInIdList;
-}
+#endif
+}
+
+#if H_MV_6_HRD_O0217_13
+Int    TComVPS::getNumOutputLayerSets() 
+{
+  Int numOutputLayerSets = getVpsNumberLayerSetsMinus1( ) + 1; 
+  if ( getMoreOutputLayerSetsThanDefaultFlag( ) )
+  {      
+    numOutputLayerSets += (getNumAddOutputLayerSetsMinus1( ) + 1); 
+  }
+  return numOutputLayerSets; 
+}
+#endif
+
 Int TComVPS::getNumViews()
 {
@@ -2104,4 +2154,42 @@
   return dependentFlag;
 }
+
+#if H_MV_6_HRD_O0217_13
+Void TComVPS::deriveLayerSetLayerIdList()
+{
+  m_layerSetLayerIdList.resize( getVpsNumLayerSetsMinus1() + 1 ); 
+  for (Int i = 0; i <= getVpsNumLayerSetsMinus1(); i++ )
+  {
+    for( Int m = 0; m  <= getVpsMaxLayerId(); m++ )
+    {
+      if( getLayerIdIncludedFlag( i, m) ) 
+      {
+        m_layerSetLayerIdList[ i ].push_back( m );        
+      }
+    }
+  }
+}
+
+Void TComVPS::deriveTargetLayerIdLists()
+{
+  m_targetDecLayerIdLists.resize( getNumOutputLayerSets() ); 
+  m_targetOptLayerIdLists.resize( getNumOutputLayerSets() ); 
+
+  for (Int targetOptLayerSetIdx = 0; targetOptLayerSetIdx < getNumOutputLayerSets(); targetOptLayerSetIdx++ )
+  {
+    Int targetDecLayerSetIdx = getOutputLayerSetIdxMinus1( targetOptLayerSetIdx ) + 1;     
+    Int lsIdx                = targetDecLayerSetIdx;
+
+    for( Int j = 0; j < getNumLayersInIdList( lsIdx ); j++ )
+    {
+      m_targetDecLayerIdLists[targetOptLayerSetIdx].push_back( m_layerSetLayerIdList[ lsIdx ][ j ] ); 
+      if( getOutputLayerFlag( targetOptLayerSetIdx, j  )) // This seems to be wrong in draft text
+      {
+        m_targetOptLayerIdLists[targetOptLayerSetIdx].push_back( m_layerSetLayerIdList[ lsIdx ][ j ] );
+      }
+    }  
+  }
+}
+#endif
 #endif // H_MV
 
@@ -2157,5 +2245,11 @@
 , m_spsInferScalingListFlag   ( false )
 , m_spsScalingListRefLayerId  ( 0 )
+
+#if !H_MV_6_PS_REP_FORM_18_19_20
 , m_updateRepFormatFlag       ( true ) 
+#else
+, m_updateRepFormatFlag       ( false ) 
+, m_spsRepFormatIdx           ( 0 )
+#endif
 , m_interViewMvVertConstraintFlag (false)
 #endif
@@ -2173,4 +2267,27 @@
   ::memset(m_ltRefPicPocLsbSps, 0, sizeof(m_ltRefPicPocLsbSps));
   ::memset(m_usedByCurrPicLtSPSFlag, 0, sizeof(m_usedByCurrPicLtSPSFlag));
+#if H_MV_6_PSEM_O0142_3
+  m_spsExtensionFlag = false; 
+  for( Int i = 0; i < PS_EX_T_MAX_NUM; i++ ) 
+  {
+    m_spsExtensionTypeFlag[ i ] = false;
+  }
+#endif
+#if H_MV_6_SHVC_O0098_36
+  m_numScaledRefLayerOffsets = 0; 
+
+  for (Int i = 0; i < MAX_NUM_SCALED_REF_LAYERS; i++ )
+  {
+    m_scaledRefLayerId             [i] = -1;
+  }
+
+  for (Int i = 0; i < MAX_NUM_LAYERS; i++ )
+  {
+    m_scaledRefLayerLeftOffset     [i] = 0;
+    m_scaledRefLayerTopOffset      [i] = 0;
+    m_scaledRefLayerRightOffset    [i] = 0;
+    m_scaledRefLayerBottomOffset   [i] = 0;
+  }
+#endif
 }
 
@@ -2353,7 +2470,13 @@
   if ( layerIdCurr > 0 )
   { 
+#if H_MV_6_PS_REP_FORM_18_19_20
+    Int            repFormatIdx = getUpdateRepFormatFlag() ?  getSpsRepFormatIdx() : vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ;
+    TComRepFormat* repFormat    = vps->getRepFormat( repFormatIdx ); 
+#else
     TComRepFormat* repFormat = vps->getRepFormat( vps->getVpsRepFormatIdx( vps->getLayerIdInVps( layerIdCurr ) ) ); 
+
     if ( !getUpdateRepFormatFlag() )
     {        
+#endif
       setChromaFormatIdc( repFormat->getChromaFormatVpsIdc() );         
       //// ToDo: add when supported: 
@@ -2368,6 +2491,10 @@
       setBitDepthC             ( repFormat->getBitDepthVpsChromaMinus8() + 8 ); 
       setQpBDOffsetC           ( (Int) (6* ( getBitDepthC() -8 ) ) );
+#if !H_MV_6_PS_REP_FORM_18_19_20
     }
     else
+#else
+    if ( getLayerId() > 0 && getUpdateRepFormatFlag() )
+#endif
     {
       assert( getChromaFormatIdc()      <=  repFormat->getChromaFormatVpsIdc()         ); 
@@ -2398,4 +2525,5 @@
   }
 }
+
 #endif
 #if H_3D
@@ -2668,5 +2796,5 @@
 #if H_MV
 Void TComSlice::createInterLayerReferencePictureSet( TComPicLists* ivPicLists, std::vector<TComPic*>& refPicSetInterLayer0, std::vector<TComPic*>& refPicSetInterLayer1 )
-{
+{  
   refPicSetInterLayer0.clear(); 
   refPicSetInterLayer1.clear(); 
@@ -2713,7 +2841,9 @@
 
 }
+
+
 Void TComSlice::markIvRefPicsAsUnused( TComPicLists* ivPicLists, std::vector<Int> targetDecLayerIdSet, TComVPS* vps, Int curLayerId, Int curPoc )
 {
-  // Fill targetDecLayerIdSet with all layers if empty. 
+  // Fill targetDecLayerIdSet with all layers if empty (at encoder side) 
   if (targetDecLayerIdSet.size() == 0 )    
   {
@@ -2722,5 +2852,5 @@
       targetDecLayerIdSet.push_back( vps->getLayerIdInNuh( layerIdInVps ) ); 
     }
-  }     
+  }  
 
   Int numTargetDecLayers = (Int) targetDecLayerIdSet.size(); 
@@ -2731,6 +2861,6 @@
     {
       break; 
+    }        
   }        
-  }        
 
   for( Int i = 0; i <= latestDecIdx; i++ ) 
@@ -2739,28 +2869,35 @@
     {
       TComPic* pcPic = ivPicLists->getPic( targetDecLayerIdSet[ i ], curPoc ); 
-      if( pcPic->getSlice(0)->isReferenced() && pcPic->getSlice(0)->getTemporalLayerNonReferenceFlag() ) 
-      { 
-        Bool remainingInterLayerReferencesFlag = false; 
-        for( Int j = latestDecIdx + 1; j < numTargetDecLayers; j++ )
+#if H_MV_LAYER_WISE_STARTUP
+      if ( pcPic )
+      {
+#endif
+        if( pcPic->getSlice(0)->isReferenced() && pcPic->getSlice(0)->getTemporalLayerNonReferenceFlag() ) 
         { 
-          TComVPS* vpsSlice = pcPic->getSlice(0)->getVPS(); 
-          if ( vps->nuhLayerIdIncluded( targetDecLayerIdSet[ j ] ) )
+          Bool remainingInterLayerReferencesFlag = false; 
+          for( Int j = latestDecIdx + 1; j < numTargetDecLayers; j++ )
+          { 
+            TComVPS* vpsSlice = pcPic->getSlice(0)->getVPS(); 
+            if ( vps->nuhLayerIdIncluded( targetDecLayerIdSet[ j ] ) )
+            {
+              for( Int k = 0; k < vpsSlice->getNumDirectRefLayers( targetDecLayerIdSet[ j ] ); k++ )
+              {
+                if ( targetDecLayerIdSet[ i ] == vpsSlice->getRefLayerId( targetDecLayerIdSet[ j ],  k  ) )
+                {
+                  remainingInterLayerReferencesFlag = true;
+                }
+              }
+            }
+          }
+          if( !remainingInterLayerReferencesFlag )
           {
-            for( Int k = 0; k < vpsSlice->getNumDirectRefLayers( targetDecLayerIdSet[ j ] ); k++ )
-            {
-              if ( targetDecLayerIdSet[ i ] == vpsSlice->getRefLayerId( targetDecLayerIdSet[ j ],  k  ) )
-              {
-                remainingInterLayerReferencesFlag = true;
+            pcPic->getSlice(0)->setReferenced( false );                   
           }
         }
-          }
-        }
-        if( !remainingInterLayerReferencesFlag )
-        {
-          pcPic->getSlice(0)->setReferenced( false );                   
-      }
-    }
-  }
-}
+#if H_MV_LAYER_WISE_STARTUP
+      }
+#endif
+    }
+  }
 }
 
@@ -2773,5 +2910,5 @@
     {      
       if (rIdx == 0 && li == 0) m_apcRefPicList[li][rIdx]->print( true );
-        
+
       m_apcRefPicList[li][rIdx]->print( false );
     }
@@ -2816,4 +2953,53 @@
   return pcPic;
 }
+
+
+#if H_MV_6_ILDDS_ILREFPICS_27_34
+Int  TComSlice::getRefLayerPicFlag( Int i ) 
+{
+  TComVPS* vps = getVPS(); 
+  Int refLayerIdx = vps->getLayerIdInVps( vps->getRefLayerId( getLayerId(), i ) ); 
+
+  Bool refLayerPicFlag = ( vps->getSubLayersVpsMaxMinus1( refLayerIdx ) >=  getTLayer() )  && 
+    ( vps->getMaxTidIlRefPicsPlus1( refLayerIdx, vps->getLayerIdInVps( getLayerId() )) > getTLayer() ); 
+
+  return refLayerPicFlag;       
+}    
+
+Int TComSlice::getRefLayerPicIdc( Int j ) 
+{  
+  Int refLayerPicIdc = -1; 
+  Int curj = 0; 
+  for( Int i = 0;  i < getVPS()->getNumDirectRefLayers( getLayerId()) ; i++ )
+  {
+    if( getRefLayerPicFlag( i ) )
+    {
+      if ( curj == j ) 
+      {
+        refLayerPicIdc = i;         
+        break;
+      }
+      curj++; 
+    }
+  }
+
+  assert( curj == j ); 
+  assert( refLayerPicIdc != -1 ); 
+  return refLayerPicIdc; 
+}
+
+Int  TComSlice::getNumRefLayerPics( )
+{  
+  Int numRefLayerPics = 0; 
+  for( Int i = 0;  i < getVPS()->getNumDirectRefLayers( getLayerId()) ; i++ )
+  {
+    numRefLayerPics += getRefLayerPicFlag( i ); 
+  }
+  return numRefLayerPics; 
+}
+#endif
+
+
+
 Int TComSlice::getNumActiveRefLayerPics()
 {
@@ -2826,5 +3012,9 @@
   else if (getVPS()->getAllRefLayersActiveFlag() )
   {
+#if H_MV_6_ILDDS_ILREFPICS_27_34
+    numActiveRefLayerPics = getNumRefLayerPics(); 
+#else
     numActiveRefLayerPics = getVPS()->getNumDirectRefLayers( getLayerId() );
+#endif
   }
   else if ( !getInterLayerPredEnabledFlag() )
@@ -2834,5 +3024,9 @@
   else if( getVPS()->getMaxOneActiveRefLayerFlag() || getVPS()->getNumDirectRefLayers( getLayerId() ) == 1 )
   {
+#if H_MV_6_ILDDS_ILREFPICS_27_34
+    numActiveRefLayerPics = getRefLayerPicFlag( 0 ) ? 1 : 0; 
+#else
     numActiveRefLayerPics = 1; 
+#endif
   }
   else
@@ -3434,4 +3628,7 @@
 TComVPSVUI::TComVPSVUI()
 {
+#if H_MV_6_PS_O0223_29
+  m_crossLayerIrapAlignedFlag = true; 
+#endif
   m_bitRatePresentVpsFlag = false;
   m_picRatePresentVpsFlag = false;
@@ -3461,4 +3658,80 @@
     }
   }
-}
-#endif
+#if H_MV_6_PS_O0118_33  
+  for ( Int i = 0; i < MAX_NUM_VIDEO_SIGNAL_INFO; i++ )
+  {
+    m_videoSignalInfo          [i] = NULL;     
+  }
+#endif
+
+#if H_MV_6_HRD_O0164_15
+  m_vpsVuiBspHrdPresentFlag = false; 
+  m_vpsVuiBspHrdParameters  = new TComVpsVuiBspHrdParameters();
+#endif
+}
+
+#if H_MV_6_PS_O0118_33
+TComVPSVUI::~TComVPSVUI()
+{
+  for ( Int i = 0; i < MAX_NUM_VIDEO_SIGNAL_INFO; i++ )
+  {
+    if (m_videoSignalInfo[ i ] != NULL )      delete m_videoSignalInfo[ i ];    
+    m_videoSignalInfo    [ i ] = NULL; 
+  }
+
+#if H_MV_6_HRD_O0164_15
+  if ( m_vpsVuiBspHrdParameters ) delete m_vpsVuiBspHrdParameters;
+  m_vpsVuiBspHrdParameters = NULL; 
+#endif
+}
+#endif
+
+#if H_MV_6_PS_REP_FORM_18_19_20
+Void TComRepFormat::inferChromaAndBitDepth( TComRepFormat* prevRepFormat, Bool encoderFlag )
+{
+  if ( !encoderFlag )
+  {
+    setChromaAndBitDepthVpsPresentFlag( prevRepFormat->getChromaAndBitDepthVpsPresentFlag() );
+    setSeparateColourPlaneVpsFlag     ( prevRepFormat->getSeparateColourPlaneVpsFlag     () );
+    setBitDepthVpsLumaMinus8          ( prevRepFormat->getBitDepthVpsLumaMinus8          () );
+    setBitDepthVpsChromaMinus8        ( prevRepFormat->getBitDepthVpsChromaMinus8        () );
+  }
+  else
+  {
+    assert( getChromaAndBitDepthVpsPresentFlag() == prevRepFormat->getChromaAndBitDepthVpsPresentFlag() );
+    assert( getSeparateColourPlaneVpsFlag     () == prevRepFormat->getSeparateColourPlaneVpsFlag     () );
+    assert( getBitDepthVpsLumaMinus8          () == prevRepFormat->getBitDepthVpsLumaMinus8          () );
+    assert( getBitDepthVpsChromaMinus8        () == prevRepFormat->getBitDepthVpsChromaMinus8        () );
+  }
+}
+#endif
+
+#if H_MV_6_HRD_O0164_15
+Void TComVpsVuiBspHrdParameters::checkLayerInBspFlag( TComVPS* vps, Int h )
+{
+  // It is a requirement of bitstream conformance that bitstream partition with index j shall not include 
+  // direct or indirect reference layers of any layers in bitstream partition i for any values of i and j 
+  // in the range of 0 to num_bitstream_partitions[ h ]  1, inclusive, such that i is less than j.
+
+  for ( Int partJ = 0; partJ < getNumBitstreamPartitions( h ); partJ++ )
+  {        
+    for ( Int partI = 0; partI < partJ; partI++ )
+    {
+      for ( Int layerJ = 0; layerJ < vps->getMaxLayersMinus1(); layerJ++ )
+      {
+        if ( m_layerInBspFlag[ h ][partJ][layerJ ] )
+        {
+          for ( Int layerI = 0; layerI < vps->getMaxLayersMinus1(); layerI++ )
+          {
+            if ( m_layerInBspFlag[ h ][partI][layerI] )
+            {
+              assert( !vps->getInDirectDependencyFlag( layerI, layerJ ) ); 
+            }
+          }
+        }
+      }
+    }
+  }
+}
+#endif
+#endif
